;##################################################################
; DIALOGAPP
;##################################################################

#include "BtnText.h"

ODS_BTNDOWN equ 0x311
ODS_BTNUP equ 0x310

CLRDISABLED equ 0x0C0C0C0


DATA SECTION
	hInstance	HANDLE 	?

CODE SECTION

START:
	; Pack the message jump table with the addresses to their handlers
	invoke GetModuleHandle, 0
	mov [hInstance],eax

	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0

	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,ebx,esi
	LOCAL BtnText[256]:%TCHAR

	cmp D[uMsg],WM_INITDIALOG
	jne >.WM_DRAWITEM
		invoke GetDlgItem,[hwnd],1001
		invoke SetWindowLong,eax,GWL_USERDATA,0xFF
		jmp >>.EXIT

	.WM_DRAWITEM
	cmp D[uMsg],WM_DRAWITEM
	jne >>.WM_COMMAND

		cmp W[wParam],1001
		jne >>.DEFPROC
			mov edi,[lParam]	;DRAWITEMSTRUCT
			mov esi,[edi+DRAWITEMSTRUCT.itemState]
			cmp esi,ODS_BTNDOWN
			jne >.ODS_BTNUP
			mov ebx,edi
			add ebx,DRAWITEMSTRUCT.rcItem
			invoke DrawFrameControl,[edi+DRAWITEMSTRUCT.hdc],ebx,DFC_BUTTON,DFCS_BUTTONPUSH + DFCS_PUSHED + DFCS_ADJUSTRECT
			// Add 2 to the left side so it gives the appearance of motion
			add D[ebx+RECT.left],2
			jmp >.DRAWTEXT

			.ODS_BTNUP
			mov ebx,edi
			add ebx,DRAWITEMSTRUCT.rcItem
			invoke DrawFrameControl,[edi+DRAWITEMSTRUCT.hdc],ebx,DFC_BUTTON,DFCS_BUTTONPUSH + DFCS_ADJUSTRECT

			.DRAWTEXT
			// Get the text
			invoke GetWindowText,[edi+DRAWITEMSTRUCT.hwndItem],addr BtnText,256
			// Get the text color
			invoke GetWindowLong,[edi+DRAWITEMSTRUCT.hwndItem],GWL_USERDATA
			test esi,ODS_DISABLED
			jz >
				mov eax,CLRDISABLED
			:
			invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],eax
			invoke DrawText,[edi+DRAWITEMSTRUCT.hdc],addr BtnText,-1,ebx,DT_CENTER + DT_VCENTER + DT_SINGLELINE
			mov eax,TRUE
			ret

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_CLOSE
		jmp >.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF
